#ifndef GERADE_Y_FO_H
#define GERADE_Y_FO_H

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>
#include <CGAL/Point_2.h>

// Template function object class which calculates the y-coordinate
// of a point at a line segment for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Gerade_y {
public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;
    typedef list<Point> PointList;
    typedef vector<Point> Points; 

    Gerade_y() {}

    Gerade_y(const NumType_& a, const NumType_& b):a_(a), b_(b) {}   
    
    NumType_ operator() (NumType_ t) const {
	assert(t>=0 && t<=1);
	return (a_*10*t + b_);
    }

private:
    NumType_ a_;
    NumType_ b_;
};
#endif //GERADE_Y_FO_H
