#ifndef CIRCEL_Y_FO_H
#define CIRCEL_Y_FO_H

#include <math.h>
#include "Types.h"
#include "Helpers.h"


// Template function object class which calculates the y-coordinate
// of a point at a circel for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Kreis_y {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;
    typedef list<Point> PointList;
    typedef vector<Point> Points; 
    
    static const double PI = 3.14159265;    

    Kreis_y(const Point& center=CGAL::ORIGIN, NumType_ radius = 1) {
	center_ = center;
	r_ = radius;
    }    

    NumType_ operator() (NumType_ t) const {
	//falls t in Grad
	//assert(t>=0 && t<=360);
	//return (center_.y() + r_*sin((t*PI)/180));
	//falls t in Radian
	return (center_.y() + r_*sin(_to_float(t)));
    }

private:
    Point center_;
    NumType_ r_;
};
#endif //CIRCEL_Y_FO_H
